"""
Sample of how to use memcache

Sources of inspiration (thanks!):
- Python appengine_oauth_library

"""





from google.appengine.api import memcache   # Temporary storage


def _gen_memcache_auth_key(service_name, auth_token):
	return "oauth_%s_%s" % (service_name, auth_token)

def _save_temporary_auth_secret(service_name, auth_token, auth_secret):
	"""
	Saves the temporary auth token and secret (done before redirecting
		user to could service for login/granting of access to service)
	"""
	key = _gen_memcache_auth_key(service_name=service_name, auth_token=auth_token)
	memcache.set(key, auth_secret, time=20*60)

def _get_temporary_auth_secret(service_name, auth_token):
	"""
	Get temporary auth secret
	"""
	key = _gen_memcache_auth_key(service_name=service_name, auth_token=auth_token)
	return memcache.get(key)





import webapp2
from jinja2 import Template as JinjaTemplate

class MainHandler(webapp2.RequestHandler):

	template_get = """
	<html>
	<body>
	{{ content }}<br />
	<br />
	Key: <pre>{{ key }}</pre>
	{% if value %}
	Value: <pre>{{ value }}</pre> 
	{% endif %}
	</body>
	</html>"""

	def get(self, mode):
		data = dict()
		data['content'] = 'Hello World!'
		data['key'] = self.request.get('key','<nothing>')

		value = self.request.get('value','')
		if value: 
			# Save
			_save_temporary_auth_secret('PROJECTPLACE', data['key'], value)
			value = ''
		else:
			# Extract and return
			value = _get_temporary_auth_secret('PROJECTPLACE', data['key'])
		data['value'] = value


		template = JinjaTemplate(self.template_get)
		self.response.write(template.render(data))










